package server

import (
	"asapo_broker/database"
	"encoding/json"
	"github.com/gorilla/mux"
	"net/http"
	"strconv"
)

func extractRequestParametersID(r *http.Request) (string, bool) {
	vars := mux.Vars(r)
	id_str, ok := vars["id"]
	if !ok {
		return "0", ok
	}
	return id_str, true
}

func getExtraParameters(r *http.Request) (string, bool) {
	vars := mux.Vars(r)
	id_str, ok := vars["id"]
	if !ok {
		return "0", ok
	}
	id_int, err := strconv.Atoi(id_str)
	if err != nil {
		return "0", false
	}
	id_key, id_ok := vars["id_key"]
	if !id_ok {
		id_key = "_id"
	}
	extraParam := database.ExtraParamId{
		Id:    id_int,
		IdKey: id_key}
	encoded, _ := json.Marshal(extraParam)
	return string(encoded), true
}

func routeGetByID(w http.ResponseWriter, r *http.Request) {
	extraParam, ok := getExtraParameters(r)
	if !ok {
		w.WriteHeader(http.StatusBadRequest)
		return
	}
	processRequest(w, r, "id", extraParam, false)
}
