package server

import (
	"asapo_broker/database"
	"encoding/json"
	"net/http"
)

type GetStreamsParams = database.GetStreamsParams

func routeGetStreams(w http.ResponseWriter, r *http.Request) {
	keys := r.URL.Query()
	// Use true as for back compatibility
	detailed := keys.Get("detailed")
	if detailed == "" {
		detailed = "true"
	}
	extraParams := GetStreamsParams{From: keys.Get("from"),
		Filter:   keys.Get("filter"),
		Detailed: detailed}
	encoded, _ := json.Marshal(extraParams)
	processRequest(w, r, "streams", string(encoded), false)
}
